// 有序循环单向链表的插入
// 要点：
//     将节点值为指定值的节点插入到有序循环单向链表中，使其仍然是一个有序循环单向链表
// 关键字：有序循环单向链表
#include <stdlib.h>

typedef struct node{
    struct node* next;
    int data;
}Node;
//////////////////////////////声明结构体自引用next域构成循环单向链表////////////////////////////
//@ shape next: c_list;

///////////////////////////////////////////声明逻辑变量//////////////////////////////////////
//@ logic Node* oldp;//用于记录函数入口处的指针p
//@ logic int n;//用于表示函数入口处链表的长度

/////////////////////////////////////insert函数的验证////////////////////////////////////////
//函数协议：
//函数前条件：p指向长为n的有序循环单向链表
//函数后条件：返回值指向长为n+1的有序循环单向链表

/*@ 
  requires 
      \c_list(p) && oldp == p && \length(p, next) == n && 0 <= n <= 1000 
      && \forall integer i:[0..n-2].p->(next:i)->data <= p->(next:i+1)->data
      ;
  assigns oldp;
  exits 
      \exit_status == 1
      ;
  ensures 
      \c_list(\result) && \length(\result, next) == n + 1 
      && (
          oldp == \null && n == 0 //原链表为空
        || 
            oldp == \result && n > 0 //头节点未发生变化即新节点插入位置并非头节点的位置
        || 
            oldp == \result->next && n > 0 //新插入的的节点变成了新链表的头结点
          ) 
      && \forall integer i:[0..n-1].\result->(next:i)->data <= \result->(next:i+1)->data
      ;
*/
Node* insert(Node* p, int const data) {
    Node* q;
    Node* s;
    int j;

    if(p == NULL){    // 空表
        p = (Node*)malloc(sizeof(Node));
        if(p == NULL){
            exit(1);
        }
        p->data = data;
        p->next = p;
        return p;
    } else {
        if(p->data > data) {        // 插在第一个节点之前
            q = p;
            j = 0;
            /*@ 
              loop invariant 
                  //整体描述单向循环链表，并描述q指针指向的节点的位置
                  \c_list(p) && oldp == p && \length(p, next) == n && 0 < n <= 1000 
                  && q == p->(next:j) && 0 <= j <= n - 1 
                  && \dangling(s) && p->data > data 
                  //整体描述链表的有序性
                  && (\forall integer i:[0..n-2].p->(next:i)->data <= p->(next:i+1)->data)
                  ;
            */ 
            while(q->next != p){
                q = q->next;
                j = j + 1;
            }
            s = (Node*)malloc(sizeof(Node));
            if(s == NULL) {
                exit(1);
            }
            s->data = data;
            s->next = p;
            q->next = s;
            return s;
        }else{                // 插在其它位置
            q = p;
            j = 0;
            /*@ 
              loop invariant 
                  oldp == p 
                  //依次描述链表中每个节点的性质
                  && \c_list_seg(p, q) && q == p->(next:j) 
                  && \c_list_seg(q, p) && p == q->(next:n-j) && \dangling(s) 
                  && 0 < n <= 1000 && 0 <= j <= n - 1 && q->data <= data 
                  //整体描述链表的有序性 
                  && (\forall integer i:[0..n-2].p->(next:i)->data <= p->(next:i+1)->data)
                  ;
            */
            while(q->next != p && q->next->data <= data){
                q = q->next;
                j = j + 1;
            }
            s = (Node*)malloc(sizeof(Node));
            if(s == NULL) {
                exit(1);
            }
            s->data = data;
            s->next = q->next;
            q->next = s;
            return p;
        }
    }
}
